' NAME: DOC2DOCX.vbs
'
' AUTHOR: Alan dot Kaplan at va dot gov
' DATE  : 1/5/2010
'
' COMMENT: Converts Word 2003 to Word 2007
' Run from GUI or 
' Syntax DOC2DOCX.vbs FilePath.DOC [True/False]
' With True/False being whether you want to delete original
' Note Line 31 has default behavior for this and for drag and drop operations
' 
'==========================================================================
Option Explicit 
dim wshShell
Set wshShell = WScript.CreateObject("WScript.Shell")
Const xlnormal = -4143 
Dim fso, oWord, objRange, bbatch, bDelete
Set fso = CreateObject("Scripting.FileSystemObject")
Dim bDropDragDelete, strCommand
Dim strFileName, strExt, strSaveAsExt, iFormatVal
'get path name, ending in \
Dim scriptpath
scriptpath = fso.Getfile(WScript.ScriptFullName).parentfolder.path & "\"
dim quote
quote=chr(34)

CheckPreReqs()

'Default for delete original file when drop and drag or only one parameter passed
bDropDragDelete = False

'script uses vbYes/No, so convert
If bDropDragDelete = True Then 
	bDropDragDelete = vbYes
Else
	bDropDragDelete = vbNo
End If 
	
Select Case WScript.Arguments.Count
	Case 0
		strFileName = WordOpenDialog() 
		If strFileName = "" Then WScript.Quit
		bDelete = msgBox ("Delete file after converting?",vbYesNoCancel, "Delete Original?")
		If bDelete = vbCancel Then WScript.Quit
	Case 1	
		strFileName = WScript.Arguments(0)
		bbatch = True 
		bDelete = bDropDragDelete
	Case 2	
		strFileName = WScript.Arguments(0)
		bbatch = True 
		If UCase(WScript.Arguments(1)) = "TRUE" Then 
			bDelete = vbYes
		Else	'Use default
			bDelete = bDropDragDelete
		End If 
End Select 

If Not fso.FileExists(strFileName) Then
	WScript.Echo strFileName & " not found"
	WScript.Quit
End If 

If len(fso.GetExtensionName(strFileName)) > 3 Then
	WScript.Echo "No conversion required for " & strFileName
	WScript.Quit
End If 

Dim strOldExt 
strOldExt = fso.GetExtensionName(strFileName)

If  ucase(strOldExt) <> "DOC" And strOldExt <> "DOT"   Then
	WScript.Echo strFileName & " is not an Word 2003 file, quitting"
	WScript.Quit
End If 

Dim f, dCreated, dLastAccessed,dLastModified
Set f = fso.getfile(strFileName)
dCreated = TouchTime(f.DateCreated)
dLastAccessed = TouchTime(f.DateLastAccessed)
dLastModified = TouchTime(f.DateLastModified)

'oWord.DisplayAlerts=False ' don't display overwrite prompt.

Dim objDocument
Set objDocument = oWord.Documents.Open(strFileName)

Dim bHasCode
bHasCode = HasCode()

If bHasCode Then 
	Select Case ucase(strOldExt)
		Case "DOT"
			strSaveAsExt = "DOTM"
		Case "DOC"
			strSaveAsExt = "DOCM"
	End Select
Else
	Select Case ucase(strOldExt)		
		Case "DOT"
			strSaveAsExt = "DOTX"
		Case "DOC"
			strSaveAsExt = "DOCX" 
 	End Select 
End If 

'see, http://msdn.microsoft.com/en-us/library/bb238158.aspx
Select Case ucase(strSaveAsExt)
	Case "DOCX"
		iFormatVal = 12
	Case "DOCM"
		iFormatVal = 13
	Case "DOTX"
		iFormatVal = 14
	Case "DOTM"
		iFormatVal = 15
 	Case Else
 		iFormatVal = 16 ' Default
End Select

Dim strNewFileName
strNewFileName = replace(strFileName,strOldExt,strSaveAsExt)

oWord.ActiveDocument.Convert() 'avoid compatibility mode
oWord.ActiveDocument.SaveAs  strNewFileName,iFormatVal
oWord.ActiveDocument.Close
oWord.Quit

'Set Date Created
strCommand = quote & scriptpath & "touch.exe" & quote & " -C -t " & dCreated & Space(1) & quote & strNewFileName& quote
wshShell.Run strCommand ,0,True

'Set Date Last Modified
strCommand = quote & scriptpath & "touch.exe" & quote & " -m -t " & dLastModified & Space(1) & quote & strNewFileName& quote
wshShell.Run strCommand ,0,True

'Set Date last Accessed
strCommand = quote & scriptpath & "touch.exe" & quote & " -a -t " & dLastAccessed & Space(1) & quote & strNewFileName& quote
wshShell.Run strCommand ,0,True

If bDelete = vbYes Then
	fso.DeleteFile strFileName,True
	WScript.Sleep 1000
End If 

If Not bbatch Then 
	wshshell.popup  strFileName & " converted to " & strNewFileName,5,"Done"
Else
	WScript.Echo strFileName & " converted to " & strNewFileName
End If 



' ========== Functions and Subs ===================

Function WordOpenDialog()
	dim strStartDir: strStartDir = wshShell.ExpandEnvironmentStrings("%USERPROFILE%\DESKTOP")

	'Set oWord = oWord.Application
	Dim Dlg

	Set Dlg = oWord.FileDialog(1) 'msoFileDialogFilePicker
	With Dlg
	 	.Filters.Clear
    	.Filters.Add "Word document", "*.doc"
		.InitialView = 1 'msoFileDialogViewList		
		.InitialFileName  = strStartDir 
	    .Title = "Select the file you want to convert"
	    .AllowMultiSelect = False
	    
	    If .Show = -1 Then
			WordOpenDialog = dlg.SelectedItems(1)
	    Else
			WordOpenDialog = ""
	    End If
	End With
		oWord.Visible = False
End Function 


        
Function HasCode()
	On Error Resume Next
	HasCode = False
	Dim VBProj 'As VBIDE.VBProject
	Set VBProj = objDocument.VBProject
	If Err <> 0 Then 
		MsgBox Err.Description & "You must trust all macros and set VBA access for this to work."
		oWord.quit
		WScript.Quit
	End If 
	
	Dim VBComp 'As VBIDE.VBComponent
	For Each VBComp In VBProj.VBComponents
		If VBComp.Type = 1 Then   
			HasCode = True
			'WScript.Echo "Code Found"
			Exit Function 
		End If 
	Next 
End Function 

Sub CheckPreReqs()
	Dim retval, message
	Set oWord = CreateObject("Word.Application") 
	If Err <> 0 Then 'Word not installed
		Err.Clear
		On Error GoTo 0
		MsgBox "To convert to Word, you must have Word installed.",vbCritical + vbOKOnly,"Fatal Error"
		WScript.Quit
	End If

	oWord.Visible = False	
	If Not fso.FileExists( scriptpath & "touch.exe") Then 
	message = "This script converts Word files from DOC to DOCX or DOCM, preserving " & _
	"all date time stamps. It requires touch.exe from the demo project at: " & vbNewLine & _
	"http://www.codeproject.com/KB/applications/touch_win.aspx.  Go there now?"
	retval = MsgBox (message,vbYesNoCancel + vbQuestion,"Required File")
		If retval = vbYes Then
			wshShell.Run "http://www.codeproject.com/KB/applications/touch_win.aspx",1,False 
		End If 
	WScript.Quit
	End If 
	
End Sub 

Function TouchTime(dDateTime)
	'Wow, this was annoying.
	'WScript.Echo dDateTime
	Dim a, strDate, strTime, bAdd, iHours
	bAdd = True 
	a = Split(dDateTime,space(1))
	strDate = Trim(a(0))
	strTime = a(1)
	If a(2) = "AM" Then bAdd = False
	
	strTime = Trim(strTime)

	
	a = Split(strTime,":")
	If bAdd Then 
		iHours = a(0) + 12
	Else
		iHours = PadNum(a(0))
	End If 
	
	strTime = CStr(iHours)  & PadNum(a(1)) & "." & PadNum(a(2))	
	
	a = split(strDate,"/")
	strDate = a(2) & padnum(a(0)) & padnum(a(1))

	TouchTime = strDate &strTime
'	WScript.Echo TouchTime & VbCrLf 
End Function 

Function PadNum(strNum)
	If Len(strnum) = 1 Then 
		padnum = "0" & strnum
	Else 
		PadNum = strNum
	End If 
End Function 
