' NAME: XLS2XLSX.vbs
'
' AUTHOR: Alan dot Kaplan at va dot gov
' DATE  : 10/20/2009
'
' COMMENT: Converts Excel 2003 to Excel 2007
' Run from GUI or 
' Syntax XLS2XLSX.vbs FilePath.xls [True/False]
' With True/False being whether you want to delete original
' Note Line 31 has default behavior for this and for drag and drop operations
' 
'==========================================================================
Option Explicit 
dim wshShell
Set wshShell = WScript.CreateObject("WScript.Shell")
Const xlnormal = -4143 
Dim fso, oXL, objRange, bbatch, bDelete
Set fso = CreateObject("Scripting.FileSystemObject")
Dim bDropDragDelete, strCommand
Dim strFileName, strExt, strSaveAsExt, iFormatVal
Dim oWS	
'get path name, ending in \
Dim scriptpath
scriptpath = fso.Getfile(WScript.ScriptFullName).parentfolder.path & "\"
dim quote
quote=chr(34)

CheckPreReqs()

'Default for delete original file when drop and drag or only one parameter passed
bDropDragDelete = False

'script uses vbYes/No, so convert
If bDropDragDelete = True Then 
	bDropDragDelete = vbYes
Else
	bDropDragDelete = vbNo
End If 
	
Select Case WScript.Arguments.Count
	Case 0
		strFileName = ExcelOpenDialog("Choose an Excel 2003 file", _
		"Excel 2003 Files (*.xls),*.xls" ) 
		If strFileName = 0 Then WScript.Quit
		bDelete = msgBox ("Delete file after converting?",vbYesNoCancel, "Delete Original?")
		If bDelete = vbCancel Then WScript.Quit
	Case 1	
		strFileName = WScript.Arguments(0)
		bbatch = True 
		bDelete = bDropDragDelete
	Case 2	
		strFileName = WScript.Arguments(0)
		bbatch = True 
		If UCase(WScript.Arguments(1)) = "TRUE" Then 
			bDelete = vbYes
		Else	'Use default
			bDelete = bDropDragDelete
		End If 
End Select 

If Not fso.FileExists(strFileName) Then
	WScript.Echo strFileName & " not found"
	WScript.Quit
End If 

If len(fso.GetExtensionName(strFileName)) > 3 Then
	WScript.Echo "No conversion required for " & strFileName
	WScript.Quit
End If 

If ucase(fso.GetExtensionName(strFileName)) <> "XLS" Then
	WScript.Echo strFileName & " is not an Excel 2003 file, quitting"
	WScript.Quit
End If 

Dim f, dCreated, dLastAccessed,dLastModified
Set f = fso.getfile(strFileName)
dCreated = TouchTime(f.DateCreated)
dLastAccessed = TouchTime(f.DateLastAccessed)
dLastModified = TouchTime(f.DateLastModified)

oXL.DisplayAlerts=False ' don't display overwrite prompt.
'oXL.Workbooks.Open(strFileName)
Dim objWorkbook
Set objWorkbook = oXL.Workbooks.Open(strFileName)

If HasCode() Then 
	strSaveAsExt = "xlsm"
Else
	strSaveAsExt = "xlsx" 
End If 

Select Case lcase(strSaveAsExt)
 	Case "xlsb"
 		iFormatVal = 50
	Case "xlsx"
		iFormatVal = 51
	Case "xlsm"
		iFormatVal = 52
 	Case "xls"
 		iFormatVal = 56
End Select

strext =  fso.getextensionname(strFileName)
Dim strNewFileName
strNewFileName = replace(strFileName,strExt,strSaveAsExt)
oXL.ActiveWorkBook.SaveAs strNewFileName,iFormatVal,,,,,,,True 'overwrite existing
oXL.ActiveWorkBook.Close
oXL.Quit


'Set Date Created
strCommand = quote & scriptpath & "touch.exe" & quote & " -C -t " & dCreated & Space(1) & quote & strNewFileName& quote
wshShell.Run strCommand ,0,True

'Set Date Last Modified
strCommand = quote & scriptpath & "touch.exe" & quote & " -m -t " & dLastModified & Space(1) & quote & strNewFileName& quote
wshShell.Run strCommand ,0,True

'Set Date last Accessed
strCommand = quote & scriptpath & "touch.exe" & quote & " -a -t " & dLastAccessed & Space(1) & quote & strNewFileName& quote
wshShell.Run strCommand ,0,True

If bDelete = vbYes Then
	fso.DeleteFile strFileName,True
	WScript.Sleep 1000
End If 


If Not bbatch Then 
	wshshell.popup  strFileName & " converted to " & strNewFileName,5,"Done"
Else
	WScript.Echo strFileName & " converted to " & strNewFileName
End If 

' ========== Functions and Subs ===================

Function ExcelOpenDialog( sPrompt, sFilter) 
	ExcelOpenDialog = oXL.GetOpenFilename ( sFilter, , sPrompt) 	 
End Function 

        
Function HasCode()
	HasCode = False
	Dim VBProj 'As VBIDE.VBProject
	Set VBProj = objWorkBook.VBProject
	
	Dim VBComp 'As VBIDE.VBComponent
	For Each VBComp In VBProj.VBComponents
		If VBComp.Type = 1 Then   
			HasCode = True
			'WScript.Echo "Code Found"
			Exit Function 
		End If 
	Next 
End Function 

Sub CheckPreReqs()
	Dim retval, message
	Set oXL = CreateObject("Excel.Application") 
	If Err <> 0 Then 'Excel not installed
		Err.Clear
		On Error GoTo 0
		MsgBox "To convert to Excel, you must have Excel installed.",vbCritical + vbOKOnly,"Fatal Error"
		WScript.Quit
	End If
	
	If Not fso.FileExists( scriptpath & "touch.exe") Then 
	message = "This script converts Excel files from XLS to XLSX or XLSM, preserving " & _
	"all date time stamps. It requires touch.exe from the demo project at: " & vbNewLine & _
	"http://www.codeproject.com/KB/applications/touch_win.aspx.  Go there now?"
	retval = MsgBox (message,vbYesNoCancel + vbQuestion,"Required File")
		If retval = vbYes Then
			wshShell.Run "http://www.codeproject.com/KB/applications/touch_win.aspx",1,False 
		End If 
	WScript.Quit
	End If 
	
End Sub 

Function TouchTime(dDateTime)
	'Wow, this was annoying.
	'WScript.Echo dDateTime
	Dim a, strDate, strTime, bAdd, iHours
	bAdd = True 
	a = Split(dDateTime,space(1))
	strDate = Trim(a(0))
	strTime = a(1)
	If a(2) = "AM" Then bAdd = False
	
	strTime = Trim(strTime)

	
	a = Split(strTime,":")
	If bAdd Then 
		iHours = a(0) + 12
	Else
		iHours = PadNum(a(0))
	End If 
	
	strTime = CStr(iHours)  & PadNum(a(1)) & "." & PadNum(a(2))	
	
	a = split(strDate,"/")
	strDate = a(2) & padnum(a(0)) & padnum(a(1))

	TouchTime = strDate &strTime
'	WScript.Echo TouchTime & VbCrLf 
End Function 

Function PadNum(strNum)
	If Len(strnum) = 1 Then 
		padnum = "0" & strnum
	Else 
		PadNum = strNum
	End If 
End Function 
